//##################################################################################################
//
//  Ceetron Result Calculator Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2019, Ceetron AS
//##################################################################################################
#pragma once

#include "crchlLogger.h"
#include <string>


//==================================================================================================
//
// 
//
//==================================================================================================
class TDLogger : public crchl::Logger
{
public:
    void                error(std::string message);
    void                info(std::string message);

    static std::string  printf(const char* format, ...);
    
    virtual void        log(Logger::Level messageLevel, const std::string& message);
};


//==================================================================================================
//
// 
//
//==================================================================================================
class TDLogging
{
public:
    static TDLogger*    loggerInstance();
};


// Helper macros for writing log messages
#define TD_LOG_ERROR(theMessage) TDLogging::loggerInstance()->error((theMessage))
#define TD_LOG_INFO(theMessage)  TDLogging::loggerInstance()->info((theMessage))


