//##################################################################################################
//
//  Ceetron Result Calculator Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2019, Ceetron AS
//##################################################################################################
#pragma once

#include "CRCResultCalculator.h"

// Remove override keyword if not supported
#ifndef CRC_SUPPORTS_OVERRIDE_KEYWORD
#define override
#endif


//==================================================================================================
//
// 
//
//==================================================================================================
class MinimalCalculator : public CRCResultCalculator
{
public:
    MinimalCalculator();
    virtual ~MinimalCalculator();

    virtual bool    initialize(const CRCHostMetaData& hostMetaData, const CRCInitOptions& options, CRCCalculatorMetaData* calculatorMetaData, CRCError* error) override;

    virtual void    getCalculatorParams(CRCCalculatorParams* calculatorParams) const override;
    virtual bool    setCalculatorParams(const CRCCalculatorParams& calculatorParams) override;
    virtual void    calculateValue(const double* inputArr, size_t inputArraySize, double* outputArr, size_t outputArraySize) const override;
};
