//##################################################################################################
//
//  Ceetron Result Calculator Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2019, Ceetron AS
//##################################################################################################
#pragma once

#include "CRCPlugin.h"
#include "CRCResultCalculator.h"
#include "CRCLogHelper.h"

// Remove override keyword if not supported
#ifndef CRC_SUPPORTS_OVERRIDE_KEYWORD
#define override
#endif


//==================================================================================================
//
// 
//
//==================================================================================================
class ParamExampleCalculator : public CRCResultCalculator
{
public:
    ParamExampleCalculator(CRC_LogFunc logFunc);
    virtual ~ParamExampleCalculator();

    virtual bool    initialize(const CRCHostMetaData& hostMetaData, const CRCInitOptions& options, CRCCalculatorMetaData* calculatorMetaData, CRCError* error) override;

    virtual void    getCalculatorParams(CRCCalculatorParams* calculatorParams) const override;
    virtual bool    setCalculatorParams(const CRCCalculatorParams& calculatorParams) override;
    virtual void    calculateValue(const double* inputArr, size_t inputArraySize, double* outputArr, size_t outputArraySize) const override;

private:
    CRCLogHelper    m_logHelper;
    double          m_scaleFactor;
};
