//##################################################################################################
//
//  Ceetron Result Calculator Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2019, Ceetron AS
//##################################################################################################
#pragma once

// Makes it easier to check on the current GCC version
#ifdef __GNUC__
// 40302 means version 4.3.2.
#define CRCHL_GCC_VER  (__GNUC__*10000 + __GNUC_MINOR__*100 + __GNUC_PATCHLEVEL__)
#endif  

// Helper macro to disable (ignore) compiler warnings on GCC
// The needed pragma is only available in GCC for versions 4.2.x and above
#if defined(__GNUC__) && (CRCHL_GCC_VER >= 40200)
#define CRCHL_DO_PRAGMA(x) _Pragma(#x)
#define CRCHL_GCC_DIAGNOSTIC_IGNORE(OPTION_STRING) CRCHL_DO_PRAGMA(GCC diagnostic ignored OPTION_STRING)
#else
#define CRCHL_GCC_DIAGNOSTIC_IGNORE(OPTION_STRING) 
#endif


