//##################################################################################################
//
//  Ceetron Result Calculator Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2019, Ceetron AS
//##################################################################################################

#include "crchlCalculatorMetaData.h"
#include "crchlAssert.h"


namespace crchl {

//==================================================================================================
//
//
//
//==================================================================================================

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
CalculatorMetaData::CalculatorMetaData()
{
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
CalculatorMetaData::~CalculatorMetaData()
{
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
void CalculatorMetaData::addInputResultIndex(crc_size_t resultIndex)
{
    m_inputResultIndices.push_back(resultIndex);
}
    

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
const std::vector<crc_size_t>& CalculatorMetaData::inputResultIndices() const
{
    return m_inputResultIndices;
}

    
//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
void CalculatorMetaData::setOutputResultType(CRCResultType resultType)
{
    m_resultType = resultType;
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
CRCResultType CalculatorMetaData::outputResultType() const
{
    return m_resultType;
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
void CalculatorMetaData::setOutputResultName(const CRCString& resultName)
{
    m_resultName = resultName;
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
const CRCString& CalculatorMetaData::outputResultName() const
{
    return m_resultName;
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
void  CalculatorMetaData::setOutputResultIdString(const CRCString& idString)
{
    m_resultIdString = idString;
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
const CRCString& CalculatorMetaData::outputResultIdString() const
{
    return m_resultIdString;
}

}  // crchl
