//##################################################################################################
//
//  Ceetron Result Calculator Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2019, Ceetron AS
//##################################################################################################
#pragma once

#include "CRCCalculatorMetaData.h"

#include "crchlBase.h"

#include <vector>

// Remove override keyword if not supported
#ifndef CRC_SUPPORTS_OVERRIDE_KEYWORD
#define override
#endif

namespace crchl {
    
//==================================================================================================
//
// 
//
//==================================================================================================
class CalculatorMetaData : public CRCCalculatorMetaData
{
public:
    CalculatorMetaData();
    virtual ~CalculatorMetaData();
    
    virtual void                    setOutputResultType(CRCResultType resultType) override;
    virtual void                    setOutputResultName(const CRCString& resultName) override;
    virtual void                    setOutputResultIdString(const CRCString& idString) override;

    virtual void                    addInputResultIndex(crc_size_t resultIndex) override;
    
    CRCResultType                   outputResultType() const;
    const CRCString&                outputResultName() const;
    const CRCString&                outputResultIdString() const;
    const std::vector<crc_size_t>&  inputResultIndices() const;
    
private:
    std::vector<crc_size_t> m_inputResultIndices;
    CRCResultType           m_resultType;
    CRCString               m_resultName;
    CRCString               m_resultIdString;
};

}  // crchl
