//##################################################################################################
//
//  Ceetron Result Calculator Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2019, Ceetron AS
//##################################################################################################

#include "crchlCalculatorParams.h"

#include <limits>

namespace crchl {

//==================================================================================================
//
//
//
//==================================================================================================

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
bool CalculatorParams::hasKey(const CRCString& key) const
{
    if (m_keyValueMap.find(key) != m_keyValueMap.end())
    {
        return true;
    }
    else
    {
        return false;
    }
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
crc_double_t CalculatorParams::value(const CRCString& key) const
{
    std::map<CRCString, double>::const_iterator it = m_keyValueMap.find(key);
    if (it != m_keyValueMap.end())
    {
        return it->second;
    }
    else
    {
        return std::numeric_limits<double>::infinity();
    }
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
void CalculatorParams::setValue(const CRCString& key, crc_double_t value)
{
    m_keyValueMap[key] = value;
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
size_t CalculatorParams::keyCount() const
{
    return m_keyValueMap.size();
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
void CalculatorParams::allKeyValuePairs(std::vector<std::pair<CRCString, double> >* allPairs) const
{
    std::map<CRCString, double>::const_iterator it;
    for (it = m_keyValueMap.begin(); it != m_keyValueMap.end(); ++it)
    {
        allPairs->push_back(*it);
    }
}

} // crchl

