//##################################################################################################
//
//  Ceetron Result Calculator Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2019, Ceetron AS
//##################################################################################################
#pragma once

#include "CRCCalculatorParams.h"
#include "CRCString.h"

#include "crchlBase.h"

#include <map>
#include <vector>

// Remove override keyword if not supported
#ifndef CRC_SUPPORTS_OVERRIDE_KEYWORD
#define override
#endif

namespace crchl {

//==================================================================================================
//
//
//
//==================================================================================================
class CalculatorParams : public CRCCalculatorParams
{
public:
    virtual bool            hasKey(const CRCString& key) const override;

    virtual crc_double_t    value(const CRCString& key) const override;
    virtual void            setValue(const CRCString& key, crc_double_t value) override;

    size_t                  keyCount() const;
    void                    allKeyValuePairs(std::vector<std::pair<CRCString, double> >* allPairs) const;

private:
    std::map<CRCString, double>   m_keyValueMap;
};

} // crchl
