//##################################################################################################
//
//  Ceetron Result Calculator Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2019, Ceetron AS
//##################################################################################################

#include "crchlHostMetaData.h"


namespace crchl {

//==================================================================================================
//
//
//
//==================================================================================================

ResultInfo::ResultInfo(CRCResultType resultType, const CRCString& resultName)
:   m_resultType(resultType),
    m_resultName(resultName)
{
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
CRCResultType ResultInfo::type() const
{
    return m_resultType;
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
const CRCString& ResultInfo::name() const
{
    return m_resultName;
}



//==================================================================================================
//
//
//
//==================================================================================================

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
crc_size_t HostMetaData::resultCount() const
{
    return m_resultInfoArr.size();
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
const CRCResultInfo& HostMetaData::resultInfo(crc_size_t index) const
{
    return m_resultInfoArr[index];
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
void HostMetaData::addResultInfo(CRCResultType resultType, const CRCString& resultName)
{
    m_resultInfoArr.push_back(ResultInfo(resultType, resultName));
}

} // crchl

