//##################################################################################################
//
//  Ceetron Result Calculator Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2019, Ceetron AS
//##################################################################################################
#pragma once


#include "CRCString.h"
#include "CRCHostMetaData.h"

#include "crchlBase.h"

#include <vector>

// Remove override keyword if not supported
#ifndef CRC_SUPPORTS_OVERRIDE_KEYWORD
#define override
#endif

namespace crchl {


//==================================================================================================
//
//
//
//==================================================================================================
class ResultInfo : public CRCResultInfo
{
public:
    ResultInfo(CRCResultType resultType, const CRCString& resultName);

    virtual CRCResultType       type() const override;
    virtual const CRCString&    name() const override;

private:
    CRCResultType   m_resultType;
    CRCString       m_resultName;
};



//==================================================================================================
//
//
//
//==================================================================================================
class HostMetaData : public CRCHostMetaData
{
public:
    virtual crc_size_t              resultCount() const override;
    virtual const CRCResultInfo&    resultInfo(crc_size_t index) const override;

    void                            addResultInfo(CRCResultType resultType, const CRCString& resultName);

private:
    std::vector<ResultInfo>     m_resultInfoArr;
};

} // crchl
