//##################################################################################################
//
//  Ceetron Result Calculator Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2019, Ceetron AS
//##################################################################################################

#include "CRCCalculatorMetaData.h"


//==================================================================================================
///
/// \class CRCCalculatorMetaData
/// 
/// Contains information on which results this calculator depends on in order to do its computations,
/// as well as the result the calculator produces
//==================================================================================================


//--------------------------------------------------------------------------------------------------
/// Set the name of the calculated result
//--------------------------------------------------------------------------------------------------
void CRCCalculatorMetaData::setOutputResultName(const CRCString& resultName)
{
    
}

//--------------------------------------------------------------------------------------------------
/// Set what kind of result to be calculated
//--------------------------------------------------------------------------------------------------
void CRCCalculatorMetaData::setOutputResultType(const CRCResultType resultType)
{
    
}

//--------------------------------------------------------------------------------------------------
/// Set the idString of the calculated result.
/// 
/// Note: If the CRCInitOptions::resultIdString() passed to CRCResultCalculator::initialize() is not
/// blank, the string provided here must either be blank or match the CRCInitOptions::resultIdString().
/// If not, instancing of the calculator will fail.
//--------------------------------------------------------------------------------------------------
void CRCCalculatorMetaData::setOutputResultIdString(const CRCString& idString)
{
    
}

//--------------------------------------------------------------------------------------------------
/// Add result to be used as input value to the calculation. 
/// The specified resultIndex is the index of the result into the array of CRCResultInfo objects
/// in CRCHostMetaData.
/// The first input result added will be the first result in the input array that will later
/// be passed to the calculateValue() function.
//--------------------------------------------------------------------------------------------------
void CRCCalculatorMetaData::addInputResultIndex(crc_size_t resultIndex)
{
}
