//##################################################################################################
//
//  Ceetron Result Calculator Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2019, Ceetron AS
//##################################################################################################
#pragma once

#include "CRCBaseTypes.h"
#include "CRCResultType.h"

class CRCString;


//==================================================================================================
//
// 
//
//==================================================================================================
class CRCResultInfo
{
public:
    virtual ~CRCResultInfo() {}

    virtual CRCResultType       type() const = 0;   ///< Result type
    virtual const CRCString&    name() const = 0;   ///< Name of the result
};



//==================================================================================================
//
// 
//
//==================================================================================================
class CRCHostMetaData
{
public:
    virtual ~CRCHostMetaData() {}

    virtual crc_size_t              resultCount() const = 0;                ///< Returns number of available results
    virtual const CRCResultInfo&    resultInfo(crc_size_t index) const = 0; ///< Returns information about specified result
};


