//##################################################################################################
//
//  Ceetron Result Calculator Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2021, Ceetron AS
//##################################################################################################

#pragma once

#include "CRCString.h"

//==================================================================================================
//
//
//
//==================================================================================================
class CRCInitOptions
{
public:
    virtual ~CRCInitOptions() {}
    
    virtual const CRCString& initString() const = 0;        ///< A user defined string to configure the calculator. Passed unchanged from the host. Might contain e.g. a mathematical expression
    virtual const CRCString& resultIdString() const = 0;    ///< The optionally prescribed idString for the result. If non-empty, the output idString set in CRCCalculatorMetaData::setOutputResultIdString() must either match this or be empty
};
