//##################################################################################################
//
//  Ceetron Result Calculator Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2019, Ceetron AS
//##################################################################################################

#pragma once

#include "CRCBaseTypes.h"
#include "CRCString.h"
#include "CRCInitOptions.h"

class CRCHostMetaData;
class CRCCalculatorMetaData;
class CRCCalculatorParams;
class CRCError;

//==================================================================================================
//
// 
//
//==================================================================================================
class CRCResultCalculator
{
public:
    CRCResultCalculator() {}
    virtual ~CRCResultCalculator() {}
    
    virtual bool    initialize(const CRCHostMetaData& hostMetaData, const CRCInitOptions& options, CRCCalculatorMetaData* calculatorMetaData, CRCError* error) = 0;

    virtual void    getCalculatorParams(CRCCalculatorParams* calculatorParams) const = 0;
    virtual bool    setCalculatorParams(const CRCCalculatorParams& calculatorParams) = 0;
    virtual void    calculateValue(const crc_double_t* inputArr, crc_size_t inputArraySize, crc_double_t* outputArr, crc_size_t outputArraySize) const = 0;
};
