//##################################################################################################
//
//  Ceetron Result Calculator Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2019, Ceetron AS
//##################################################################################################
#pragma once

#include "CRCBaseTypes.h"

#include <cstddef>
#include <cstring>


//==================================================================================================
//
// 
//
//==================================================================================================
class CRCString
{
public:
    inline CRCString();
    inline CRCString(const CRCString& other);
    inline ~CRCString();

    inline CRCString&        operator=(const CRCString& rhs);
    inline bool              operator==(const CRCString& rhs) const;
    inline bool              operator!=(const CRCString& rhs) const;
    inline bool              operator<(const CRCString& rhs) const;

    inline const crc_char_t* utf8() const;
    inline crc_size_t        byteCount() const;

    inline static CRCString  fromUtf8(const crc_char_t* utf8Ptr);
    inline static CRCString  fromChar(const crc_char_t* charPtr);

private:
    crc_char_t* m_str;
};

#include "CRCString.inl"


